/******************************************************************************
  * @Example IWDG
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2023/12/18
  * @brief   ÿŹιӡ"ȴιȡιϢϵͳλظ"ιֻӡһ
  *          
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλżУ
  *							
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *
  *****************************************************************************/
	
#include "PT32Y003x.h"

/**
* @brief UARTĸ
* @param 
* @retval 
*/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX
}

/**
* @brief UARTĹģʽ
* @param 
* @retval 
*/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity = UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength = UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode = UART_ParityMode_Even;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/**
* @brief UART
* @param 
* @retval 
*/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

/**
* @brief IWDG
* @param 
* @retval 
*/
void IWDG_Driver(u32 rlv)
{	
	WDG_LockCmd(IWDG, DISABLE);	//IWDGĴ
	WDG_SetReload(IWDG, rlv);   //װؼĴֵ
	WDG_ReloadCounter(IWDG);	//ι(ؼ)
  WDG_ResetCmd(IWDG, ENABLE);	//Źλʹ
	WDG_Cmd(IWDG, ENABLE);		//ʹIWDG
	WDG_LockCmd(IWDG, ENABLE);	//סIWDGĴ
}

/**
* @brief IWDGι
* @param 
* @retval 
*/
void IWDG_Feed(void)
{
	WDG_LockCmd(IWDG, DISABLE);	//IWDGĴ
	WDG_ReloadCounter(IWDG);	//ι(ؼ)
	WDG_LockCmd(IWDG, ENABLE);	//סIWDGĴ	
}

int main (void)
{
	UART_Driver();
	IWDG_Driver(32768);	//timeout=1s	
	printf("ȴιȡιϢϵͳλظ\r\n");
	while(1)
	{
		IWDG_Feed();//ιȡιϵͳʱλ
	}
}
	
 
#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %ld\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
