/******************************************************************************
  * @Example PVD
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2023/12/18
  * @brief  ⲿԴ<=3.5ʱԴ͵ѹ¼"PVD"жϡλԶ־PD4LEDƵ
  *         ֱԴ>=3.6VPVD˳жϣPD4LEDϨ           
  ******************************************************************************
  * @attention	Ϊ96001λֹͣλУ
  *  ʹø̣
  *  Ҫ蹩߽
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *****************************************************************************/
	
#include "PT32Y003x.h"

void Software_Delay(void)
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<50; x++);
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX0
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity=UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength=UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode=UART_ParityMode_Odd;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*******************************************************************************
*Function:	UART_Driver
*Description:	UARTģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void UART_Driver(void)
{
	UART_GPIO_Config();
	UART_Mode_Config();
}

void GPIO_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;	//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;	//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_NoPull;	//ƫ
	GPIO_Init(GPIOD, &GPIO_InitStructure);	//ÿ⺯ʼGPIO
	GPIO_SetBits(GPIOD, GPIO_Pin_4);			//ÿ⺯GPIO״̬
}

/*******************************************************************************
*Function:	PVD_Int_Driver
*Description:	PVDģ
*Input:		
*Return:		
*Others:
*******************************************************************************/
void PVD_Int_Driver(void)
{
	RCC_ClearFlag(RCC_FLAG_POR);
	RCC_ClearFlag(RCC_FLAG_PVD);
	RCC_ResetConfig(RCC_ResetEnable_PDRE,DISABLE);
	
	NVIC_EnableIRQ(PVD_IRQn);
	PWR_PVDLevelConfig(PWR_PVDLevel_6);//PVDֵΪ3.5V
	PWR_PVDCmd(ENABLE);				//PVDʹ
}

uint8_t PVD_Flag=0;
int main (void)
{
	GPIO_Driver();
	PVD_Int_Driver();
	while(1)
	{
		if(PVD_Flag==1)
		{
			PVD_Flag=0;
			GPIO_SetBits(GPIOD, GPIO_Pin_4);			//high
		}
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif


