/******************************************************************************
  * @Example LED
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2023/12/18
  * @brief   ͨʱ˸PD3ϵĺ
  *          
  ******************************************************************************
  * @attention	
  *  ʹø̣
  *  Ҫ蹩߽
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *****************************************************************************/
	
#include "PT32Y003x.h"

#define		LED_PROT_RED		GPIOD
#define		LED_PIN_RED	    GPIO_Pin_3

#define		LED_RED_OFF()	GPIO_SetBits(LED_PROT_RED, LED_PIN_RED)
#define		LED_RED_ON()	GPIO_ResetBits(LED_PROT_RED, LED_PIN_RED)

/**
* @brief ʱ
* @param 
* @retval 
*/
void Delay(u32 delay)
{
	while(delay > 0)
		delay--;
}

void LED_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;				      //һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = LED_PIN_RED;			  //ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_NoPull;	//ƫ
	GPIO_Init(LED_PROT_RED, &GPIO_InitStructure);			//ÿ⺯ʼGPIO
		
  GPIO_SetBits(LED_PROT_RED, LED_PIN_RED);					//GPIO״̬
}

int main (void)
{
	LED_Driver();
	while(1)
	{
		LED_RED_OFF();
		Delay(1000000);
		LED_RED_ON();
		Delay(1000000);  
	}
}
	 
#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %ld\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
