/******************************************************************************
  * @Example Timer_LED
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2023/12/18
  * @brief   ͨʱÿ1s˸PC6ϵled
  *          
  ******************************************************************************
  * @attention	 
  *  ʹø̣
  *  Ҫ蹩߽
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *****************************************************************************/
	
#include "PT32Y003x.h" 

#define		LED_PROT_RED		GPIOD
#define		LED_PIN_RED	    GPIO_Pin_3

#define		LED_RED_OFF()	GPIO_SetBits(LED_PROT_RED, LED_PIN_RED)
#define		LED_RED_ON()	GPIO_ResetBits(LED_PROT_RED, LED_PIN_RED)

void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

void LED_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;				//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = LED_PIN_RED;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_NoPull;	//ƫ
	GPIO_Init(LED_PROT_RED, &GPIO_InitStructure);				//ÿ⺯ʼGPIO
		
  GPIO_SetBits(LED_PROT_RED, LED_PIN_RED);					//GPIO״̬
}

/**
* @brief TIM2ʽ
* @param 
* @retval 
*/
void TIM2_Int_Diver(void)
{
	NVIC_InitTypeDef NVIC_InitStruct;								//һNVIC_InitTypeDef͵Ľṹ
	TIM_TimeBaseInitTypeDef  TIM_TimeBaseInitStruct;//һNVIC_InitTypeDef͵Ľṹ
	
	TIM_TimeBaseInitStruct.TIM_Prescaler = 4800-1;										 //48M/4800=0.01MHZ
	TIM_TimeBaseInitStruct.TIM_AutoReload = 10000;									 //0.01MHZ*10000=1HZ
	TIM_TimeBaseInitStruct.TIM_Direction = TIM_Direction_Up;					 //ϼ
	TIM_TimeBaseInit(TIM2, &TIM_TimeBaseInitStruct);									 //ʼTIM2
	
	TIM_ITConfig(TIM2,TIM_IT_ARI,ENABLE);									//ʱжϳʼ
	
	NVIC_InitStruct.NVIC_IRQChannel=TIM2_IRQn;								//ʱжԴ
	NVIC_InitStruct.NVIC_IRQChannelPriority=0x00;							//жȼ
	NVIC_InitStruct.NVIC_IRQChannelCmd=ENABLE;								//ʹNVIC
	NVIC_Init(&NVIC_InitStruct);															//ʼNVIC	
	
	TIM_Cmd(TIM2, ENABLE);																		//TIM2
}

u8 TIM_IT_FLAG=0;
int main (void)
{
	LED_Driver();
    TIM2_Int_Diver();
    while(1)
    {
      if(TIM_IT_FLAG)	//ȡ־Ƿ
			{
				LED_RED_OFF();
			}
		  else
			{
				LED_RED_ON();
			} 
    }
}
	
#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %ld\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
