  /******************************************************************************
  * @Example OutputBrake
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2023/12/18
  * @brief   ʹPWM̶ռձȷʱ䣬ɲ
	* 1ͨʾ
	* 	PC6,TIM1 CH1
	* 	PD4,TIM1 CH1N
	* 	Թ۲֪CH1ռձΪ80CH1NռձΪ48
  * 	ΪPWMΪװֵ99+1=100ȽֵΪ64ΪϼPWM1ģʽʱ
  *		ռձӦΪ64%16ʱ䣬ʹԭռձȱΪ64+16=8064-16=48
	* 2ͬʱҲⲿܽɲ
	* 	PB5̽VDDʱԭֹͣϿָ
	*   PB5̽GNDʱPWM
	*   ע⣬PB5ʱڵƽᵼPWMֹͣ
	* 3ͬʱҲͬɲ
	*   User KeyʱPWMֹͣ
	*   ɿUser KeyʱPWMָ
	    
  ******************************************************************************
  * @attention	 
  *  ʹø̣
  *  Ҫ蹩߽
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *****************************************************************************/
	
#include "PT32Y003x.h"

/**
* @brief TIM1ĸ
* @param 
* @retval 
*/
void TIM_GPIO_Config(void)
{
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_6, AFIO_AF_2,ENABLE);//TIM1 CH1
  GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_4, AFIO_AF_1,ENABLE);//TIM1 CH1N
	GPIO_DigitalRemapConfig(AFIOB, GPIO_Pin_5, AFIO_AF_1,ENABLE);//Brake Pin
}

void User_Key_Config(void)
{
	GPIO_InitTypeDef GPIO_InitStruct;
	GPIO_InitStruct.GPIO_Mode=GPIO_Mode_In;
	GPIO_InitStruct.GPIO_Pin=GPIO_Pin_3;
	GPIO_InitStruct.GPIO_Pull=GPIO_Pull_Up;
	GPIO_Init(GPIOC,&GPIO_InitStruct);
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_3, AFIO_AF_None,DISABLE);
	GPIO_SetBits(GPIOC,GPIO_Pin_3);
}
/**
* @brief TIM1ʽ
* @param 
* @retval 
*/
void TIM_Mode_Config(void)
{
	PWM_TimeBaseInitTypeDef PWM_TimeBaseInitType;
	PWM_OCInitTypeDef OutInit;
	PWM_BDTRInitTypeDef BDTR_Init;
	/* ģʽ --  */
	PWM_TimeBaseInitType.PWM_CenterAlignedMode = PWM_CenterAlignedMode_Disable;
	/* ģʽΪϼ */
	PWM_TimeBaseInitType.PWM_Direction = PWM_Direction_Up;
	/* ƥĴ,ۼMR0+1Ƶʺһ»ж */
	PWM_TimeBaseInitType.PWM_AutoReloadValue = 99;
	/* CNTʱ = Fcksys/(psc+1)*/
	PWM_TimeBaseInitType.PWM_Prescaler = 63;
	/* ʼTIM1*/
	PWM_TimeBaseInit(TIM1,&PWM_TimeBaseInitType);
	/* ΪPWMͨΪ1ͨ*/
	OutInit.PWM_Channel =PWM_Channel_1;
	/* ΪPWMģʽ */	
	OutInit.PWM_OCMode = TIM_OCMode_PWM1;
	/* ͻ */
	OutInit.PWM_OCNOutput = PWM_OCNOutput_Enable;		
	OutInit.PWM_OCOutput = PWM_OCOutput_Enable;  
	/* PWMʱƽ״̬ */	
	OutInit.PWM_OCIdleState = PWM_OCIdleState_Low;
	OutInit.PWM_OCNIdleState = PWM_OCNIdleState_Low;
	/* PWMռձ P = (PWM_OCValue+1) / (PWM_AutoReloadValue+1)*/	
	OutInit.PWM_OCValue = 0;
    /* PWMȽ*/	
	OutInit.PWM_OCPolarity = PWM_OCPolarity_High;
  OutInit.PWM_OCNPolarity = PWM_OCNPolarity_High;
	/* ʼPWM */
	PWM_OCInit(TIM1, &OutInit);
	
	BDTR_Init.PWM_Break=PWM_Break_Enable;//ʹɲ
	BDTR_Init.PWM_BreakSource=PWM_BreakSource_BKIN|PWM_BreakSource_SW;//ɲԴѡΪⲿܽź
	BDTR_Init.PWM_BreakPolarity=PWM_BreakPolarity_High;//ɲԴߵƽЧ
	BDTR_Init.PWM_BreakSoftwareControl=PWM_BreakSoftwareControl_Disable;
	BDTR_Init.PWM_BreakInput=PWM_BreakInput_TIMIdle;//ɲʱǿƹرPWM
	BDTR_Init.PWM_DeadTime=64*16;//ʱ䣬Ϊ16
  PWM_BDTRInit(TIM1,&BDTR_Init);
	/* ʹPWM */
	PWM_Cmd(TIM1,ENABLE);
}

/**
* @brief ʱ
* @param 
* @retval 
*/
void Delay(u32 delay)
{
	while(delay > 0)
		delay--;
}

u8 User_key_flag=1;
int main()
{
	/*TIM1*/
	TIM_GPIO_Config();
	TIM_Mode_Config();
	User_Key_Config();
	PWM_SetOCxValue(TIM1, PWM_Channel_1, 64);
	while(1)
	{
		Delay(1000);
	  if(GPIO_ReadDataBit(GPIOC,GPIO_Pin_3)&&(User_key_flag==0))
		{
			PWM_SoftwareBreak_CMD(TIM1,DISABLE);
			User_key_flag=1;
		}
		if((!GPIO_ReadDataBit(GPIOC,GPIO_Pin_3))&&(User_key_flag==1))
		{
			PWM_SoftwareBreak_CMD(TIM1,ENABLE);
			User_key_flag=0;
		}
  }
}
	
 
#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %ld\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
