/******************************************************************************
  * @Example SPI
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2023/12/18
  * @brief   ʹSPIԷգʹôϢ
  *          
  ******************************************************************************
  * @attention	
  *	ʹø:
  * ʹSPISPI MOSI MISOܽŶ̽ӣPC6PC7ж̽
  * ӶʵSPIԷգսʹô
  * ڲ96008λλ1λֹͣλУλ
	
	* ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣 
  * ̼/ͻʹаıϢκ,
  * Pai-ICκֱӣ ӻ̷𺦸
  * 
  * (C) ȨPai-IC Microelectronics  
  ******************************************************************************
  *****************************************************************************/
	
	
#include "PT32Y003x.h"
#include "spi_flash.h"

void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

/*******************************************************************************
*Function:	UART_GPIO_Config
*Description:	UART
*Input:		
*Return:		

*Others:
			úʹUARTģ
*******************************************************************************/
void UART_GPIO_Config(void)
{
	/* UARTܽŵĸù */
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_5, AFIO_AF_0,ENABLE);	//PD5 TX0
	GPIO_DigitalRemapConfig(AFIOD, GPIO_Pin_6, AFIO_AF_0,ENABLE);	//PD6 RX0
}

/*******************************************************************************
*Function:	UART_Mode_Config
*Description:	UART
*Input:		
*Return:		
*Others:
			úʼUARTģĹ乤ʽ
*******************************************************************************/
void UART_Mode_Config(void)
{
	UART_InitTypeDef  UART_InitStruct;

	/*ʼUART0*/
	UART_InitStruct.UART_BaudRate = 9600;
	UART_InitStruct.UART_WordLengthAndParity=UART_WordLengthAndParity_8D;
	UART_InitStruct.UART_StopBitLength=UART_StopBitLength_1;
	UART_InitStruct.UART_ParityMode=UART_ParityMode_Odd;
	UART_InitStruct.UART_Receiver=UART_Receiver_Enable;
	UART_InitStruct.UART_LoopbackMode=UART_LoopbackMode_Disable;
	UART_Init(UART0, &UART_InitStruct);

	/*UART0շ*/
	UART_Cmd(UART0, ENABLE);
}

/*
ʼSPIܽ
*/

void SPI_GPIO_Config(void)
{
	GPIO_DigitalRemapConfig(AFIOA, GPIO_Pin_3, AFIO_AF_1,ENABLE);	//SPI_CSֹܸ
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_5, AFIO_AF_1,ENABLE);	//SPI_SCKֹܸ
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_6, AFIO_AF_1,ENABLE);	//SPI_MOSIֹܸ
	GPIO_DigitalRemapConfig(AFIOC, GPIO_Pin_7, AFIO_AF_1,ENABLE);	//SPI_MISOֹܸ
}

void SPI_MasterMode_Config(SPI_TypeDef* SPIx)
{
	SPI_InitTypeDef  SPI_InitStructure;						//һSPI_InitTypeDef͵Ľṹ
	SPI_StructInit(&SPI_InitStructure);						//ʹĬֵʼSPI_InitStructure
	
	/* SPI ģʽ */
  SPI_InitStructure.SPI_MasterSlaveMode=SPI_MasterSlaveMode_Master;//Ϊģʽ
  SPI_InitStructure.SPI_DataFrameFormat=SPI_DataFrameFormat_8b;//֡
  SPI_InitStructure.SPI_ClockPolarity=SPI_ClockPolarity_High;//ʱӼԣ״̬ʱSCKָߵƽ
	SPI_InitStructure.SPI_ClockPhase=SPI_ClockPhase_2Edge;//ʱλݲӵڶʱӱؿʼ
	SPI_InitStructure.SPI_CSS = SPI_CSS_SoftwareControl;				//CSƣĬϳʼֵΪߵƽ
	SPI_InitStructure.SPI_Prescaler = 0;					//SPIʱӷƵϵ
  SPI_InitStructure.SPI_BaudRate=16;  //SPIԤƵ f(sck)=f(pclk)/(SPI_Prescaler*(1+SPI_Prescaler))
	SPI_Init(SPIx, &SPI_InitStructure);						//ʼSPI
	SPI_SoftwareControlCSSConfig(SPIx, SPI_SoftwareControlCSS_High);		//ƬѡźſƣCSߵƽ
	
	SPI_Cmd(SPIx, ENABLE);									//ʹSPI
}

int main (void)
{
	u8 i = 0;
	u8 tx_data[10]={1,2,3,4,5,11,22,33,44,55};
	u8 rx_data[10]={0};
	
	UART_GPIO_Config();
	UART_Mode_Config();
	SPI_GPIO_Config();
	SPI_MasterMode_Config(SPI0);
	while(i<sizeof(tx_data))
	{
		while(!SPI_GetFlagStatus(SPI0,SPI_FLAG_TXE));	//FIFOΪ
		SPI_SendData(SPI0	,tx_data[i]);
		while(!SPI_GetFlagStatus(SPI0,SPI_FLAG_RXNE));	//FIFOǿ
		rx_data[i] = SPI_ReceiveData(SPI0);			
		i++;
	}
	i=0;
	while(i<sizeof(rx_data))
	{
		Software_Delay();
		printf("rx_data[%d] = %d \r\n",i,rx_data[i]);		
		i++;
	}	
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %d\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
