/******************************************************************************
  * @Example Systick_LED
  * @author  ӦÿŶ
  * @version V1.6.0
  * @date    2023/12/18
  * @brief   ͨʱÿ1s˸PC6ϵled
  *          
  ******************************************************************************
  * @attention	 
  *  ʹø̣
  *  Ҫ蹩߽
  *
  * ǰĹָ̼, ĿͻṩйƷıϢ,Խʡǵʱ䡣
  * ̼/ͻʹаıϢκ, * Pai-IC κֱӣ ӻ̷𺦸
  *
  * (C) Ȩ Pai-IC Microelectronics
  *****************************************************************************/
	
#include "PT32Y003x.h" 

#define		LED_PROT_RED		GPIOD
#define		LED_PIN_RED	    GPIO_Pin_3

#define		LED_RED_OFF()	GPIO_SetBits(LED_PROT_RED, LED_PIN_RED)
#define		LED_RED_ON()	GPIO_ResetBits(LED_PROT_RED, LED_PIN_RED)

u32 TimingDelay;

void Software_Delay(void)//ʱ
{
	u8 i, j,x;
	for(i=0; i<200; i++)
		for(j=0; j<200; j++)
			for(x=0; x<20; x++);
}

void LED_Driver(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;				//һGPIO_InitTypeDef͵Ľṹ
	GPIO_InitStructure.GPIO_Pin = LED_PIN_RED;			//ѡҪƵGPIO
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OutPP;		//ģʽΪͨ
	GPIO_InitStructure.GPIO_Pull = GPIO_Pull_NoPull;	//ƫ
	GPIO_Init(LED_PROT_RED, &GPIO_InitStructure);				//ÿ⺯ʼGPIO
		
  GPIO_SetBits(LED_PROT_RED, LED_PIN_RED);					//GPIO״̬
}

/**
* @brief ϵͳδʱ SysTick
* @param 
* @retval 
*/
void SysTick_Init(void)
{
	u32 SYSCLK=0;
	SYSCLK = RCC_GetClockFreq(RCC_HCLK);						//HCLKʱ
	if (SysTick_Config(SYSCLK / 10))					// 100msжһ
	{ 
		while (1);
	}
}

/**
* @brief ʱʱ
* @param 
* @retval 
*/
void Delay_time(__IO u32 nTime)
{ 
	TimingDelay = nTime;	
	SysTick->CTRL |=  SysTick_CTRL_ENABLE_Msk;			//ʹSYSTIC  
	while(TimingDelay != 0);
}

/**
* @brief ȡĳSysTickжϺ SysTick_Handler()
* @param 
* @retval 
*/
void TimingDelay_Decrement(void)
{
	if (TimingDelay != 0x00)
	{ 
		TimingDelay--;
	}
}

int main(void)
{
	LED_Driver();	 
	SysTick_Init(); 									
	while (1)
	{
		Delay_time(10);									//10*100ms=1s
		GPIO_SetBits(LED_PROT_RED, LED_PIN_RED);				//Ϩ
	
		Delay_time(10);									//10*100ms=1s
		GPIO_ResetBits(LED_PROT_RED, LED_PIN_RED); 				//Ƶ
	}
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(u8* file, u32 line)
{
	/* User can add his own implementation to report the file name and line number,
	   ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
	printf("Wrong parameters value: file %s on line %ld\r\n", file, line);
	/* Infinite loop */
	while (1)
	{
	}
}
#endif
